import java
#import pawt

#import pawt.swing
#from pawt import swing
import javax
from javax import swing
import os

#from swing import JFrame
from java.lang import Character
from jarray import zeros

#Local imports
#import ExtRectangle
#from usbr.gstarsgui import JPreferencesDlg

#import sys;sys.add_package("usbr.gstarsgui")
#from usbr.gstarsgui import *
from GSTARSInputDoc import GSTARSInputDoc

from GSTARSInputView import GSTARSInputView
from GSTARSDesktopManager import GSTARSDesktopManager
from GSXSecControlDlg import GSXSecControlDlg
from GSGlassPane import GSGlassPane

from GSAboutBoxJPanel import GSAboutBoxJPanel
from GSTARSGeometryView import GSTARSGeometryView
from GSTARSSedimentView import GSTARSSedimentView
from GSTARSBoundaryView import GSTARSBoundaryView
from GSTARSOutputView import GSTARSOutputView

#from javax.help import HelpSet
#from javax.help import CSH

# Read the resource file.
## preferences = {}

## try:
##     input = open('.gstarsrc', 'r')
##     inputStrList = input.readlines()
##     input.close()

##     preferences['river color'] = java.awt.Color(eval(inputStrList[0]))
##     preferences['background color'] = java.awt.Color(eval(inputStrList[1]))
##     preferences['GSTARS location'] = inputStrList[2]

## except:
##     # Initialize empty resource list.
##     preferences = {'GSTARS location': None,
##                    'river color': java.awt.Color.red,
##                    'background color': java.awt.Color.white}

## print 'set prefs to ' + `preferences`

class gstars(swing.JFrame):
#class gstars(swing.JApplet):
    """Outer framework of the program."""

##     def init(self):
##         self.__init__()
##         swing.JApplet.init(self)

    def __init__(self, *args, **kw):
        #apply(swing.JFrame.__init__, (self,) + args, kw)
        #swing.JFrame.__init__(self, title="Untitled", name="GSTARS")
        self.setSize(660, 700)
        self.setDefaultCloseOperation(swing.WindowConstants.DO_NOTHING_ON_CLOSE)
        self.setTitle("GSTARS 2.1")
        self.setName("GSTARS")

        self.cwd = None                 # current working directory; same as
                                        #   self.fileName's directory

        # Set program icon
        #self.setIconImage(ImageIcon(self.getProperty("icons.logo")).getImage()
        icon = self.getToolkit().getImage("icon.gif")
##         if icon == None:
##             print 'getImage failure'

        self.setIconImage(swing.ImageIcon(icon).getImage())
##         mt = java.awt.MediaTracker(self)
##         mt.addImage(icon, 0)
##         try:
##             mt.waitForAll()
##             self.setIconImage(icon)
##         except java.lang.InterruptedException, ie: # InterruptedException
##             ie.printStackTrace()

        self.setGlassPane(GSGlassPane())

        self.buildMenuBar()

        #self.desktop = swing.JDesktopPane(preferredSize=java.awt.Dimension(400, 300))
        self.desktop = swing.JDesktopPane(preferredSize=(400, 300))
        scrollPane = swing.JScrollPane(
            self.desktop,
            swing.JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
            swing.JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED)

        self.getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER)

        self.statusBar = swing.JLabel("Ready")
        self.getContentPane().add(self.statusBar, java.awt.BorderLayout.SOUTH)

        self.desktop.setDesktopManager(GSTARSDesktopManager())

        #self.addWindowListener(WindowAction())
        self.windowClosing = self.fileExit

        self.componentResized = self.sizeComponent

##         self.setLocation(self.getToolkit().getScreenSize().width/3,
##                          self.getToolkit().getScreenSize().height/3)

        # The list of child frames.
        self.frameList = []

        # The information view frames
        self.geometryFrame = None
        self.sedimentFrame = None
        self.boundaryFrame = None
        self.outputFrame = None
        self.xsecControlDlg = None
        return

    def closeView(self, aView):
        """close aView
        aView: an internal frame object.
        returns: none
        side-effects: removes aView from the frameList and closes the
        frame.
        """
        retval = aView.doc.canClose()
        if retval == None:
            print 'closeView: got cancel'
            return None
        else:
            aView.doc.close()
            self.frameList.remove(aView)
            swing.JInternalFrame.dispose(aView)
            return 1

    def getView(self, doc):
        """Get the first view associated with doc.
        doc: use this document type to retrieve the associated view.
        returns: GSTARSInputView
        """
        for f in self.frameList:
            if f.doc == doc:
                return f
        return None

    def updateAllViews(self, doc, hint):
        """Instruct every view of the document to update itself.
        doc: use this document type to retrieve the associated views.
        hint: pass this hint to the update procedure.
        returns: none
        side-effects: doUpdate(hint) is called for each view.
        """
        for f in self.frameList:
            if f.doc == doc:
                f.doUpdate(hint)
        return

    def updateViewTitles(self, doc, newTitle=""):
        """Set the frame title for every view of the document.
        doc: use this document type to retrieve the associated views.
        newTitle: optional title for document window
        returns: none
        side-effects: frame title is updated
        """
        for f in self.frameList:
            if f.doc == doc:
                if newTitle == "":
                    if f.doc.fileName:
                        f.setTitle(f.doc.fileName)
                        print f.doc.fileName
                    else:
                        f.setTitle("Untitled")
                else:
                    f.setTitle(newTitle)
        return

    def buildMenuBar(self):
        """Build menu widgets from, adding from the default file menu items
        and the

        """
 	mb = swing.JMenuBar()
        mb.add(self.buildDefaultMenu())
        mb.add(self.buildWindowMenu())
        mb.add(self.buildHelpMenu())
        self.setJMenuBar(mb);

    def buildDefaultMenu(self):
        """File menu pulldown.
        returns: the file JMenu
        """
	menu = swing.JMenu("File")
        menu.setMnemonic('F')

        mitem = swing.JMenuItem("New", actionPerformed=self.fileNew)
        mitem.setMnemonic('N')
	menu.add(mitem)
        mitem = swing.JMenuItem("Open", actionPerformed=self.fileOpen)
        mitem.setMnemonic('O')
	menu.add(mitem)

        menu.addSeparator()

        mitem = swing.JMenuItem("Exit", actionPerformed=self.fileExit)
        mitem.setMnemonic('x')
	menu.add(mitem)

        return menu

    def buildWindowMenu(self):
        """Window menu pulldown.
        returns: the window JMenu
        """
	menu = swing.JMenu("Window")
        menu.setMnemonic('W')

        mitem = swing.JMenuItem("Organize",
                                actionPerformed=self.windowOrganize)
        mitem.setMnemonic('O')
	menu.add(mitem)

        return menu

    def buildHelpMenu(self):
        """Help menu pulldown.
        returns: the help JMenu
        """
	menu = swing.JMenu("Help")
        menu.setMnemonic('H')

##         mitem = swing.JMenuItem("Contents", actionPerformed=self.helpContents)
##         mitem.setMnemonic('C')
## 	menu.add(mitem)
        mitem = swing.JMenuItem("Help", actionPerformed=self.showHelp)
        mitem.setMnemonic('H')
	menu.add(mitem)

        mitem = swing.JMenuItem("About", actionPerformed=self.helpAbout)
        mitem.setMnemonic('A')
	menu.add(mitem)

        return menu

    def sizeComponent(self, event):
        # If the main app is enlarged, then enlarge the desktop as well.
        #   Don't let the desktop size ever shrink.
##         maxSize = [self.desktop.getSize().width,
##                    self.desktop.getSize().height]
##         if maxSize[0] < self.getSize().width:
##             maxSize[0] = self.getSize().width
##         if maxSize[1] < self.getSize().height:
##             maxSize[1] = self.getSize().height

##         self.desktop.setSize(java.awt.Dimension(maxSize[0], maxSize[1]))
##         self.desktop.setPreferredSize(
##             java.awt.Dimension(maxSize[0], maxSize[1]))
        return

    def fileNew(self, event):
        """Action taken on File->New."""
        newFrame = GSTARSInputView(GSTARSInputDoc(self))
        self.desktop.add(newFrame, self.desktop.DEFAULT_LAYER)
        #newFrame.setMaximum(1)

        height = float(self.getBounds().getHeight())
        width = float(self.getBounds().getWidth())

        cnt = len(self.frameList) % 5
        xdiv = width / 4.0 / 5
        ydiv = height / 4.0 / 5
        newFrame.setBounds(int(xdiv * cnt), int(ydiv * cnt),
                           int(3.0 * width / 4.0), int(3.0 * height / 4.0))
        newFrame.setMouseMode("add river node")


        self.frameList.append(newFrame)

        newFrame.setTitle("New network")
        newFrame.show()

        return

    def setStatus(self, message):
        self.statusBar.setText(message)

    def fileOpen(self, event):
        doc = GSTARSInputDoc(self)
        newFrame = GSTARSInputView(doc)

        self.getGlassPane().setVisible(1)
        try:
            if newFrame.doc.doFileOpen():
                height = float(self.getBounds().getHeight())
                width = float(self.getBounds().getWidth())

                cnt = len(self.frameList) % 5
                xdiv = width / 4.0 / 5
                ydiv = height / 4.0 / 5
                newFrame.setBounds(
                    int(xdiv * cnt), int(ydiv * cnt),
                    int(3.0 * width / 4.0), int(3.0 * height / 4.0))

                self.frameList.append(newFrame)
                self.desktop.add(newFrame, self.desktop.DEFAULT_LAYER);
                newFrame.show()

                self.updateViewTitles(doc)
                newFrame.setMouseMode("edit xsections")
                newFrame.drawable.update()
        finally:
            self.getGlassPane().setVisible(0)
            print 'destroying glass pane'
            self.getGlassPane().setEnabled(0)

        return

    def fileExit(self, event):
        # Save prefs
##         output = open('.gstarsrc', 'w')
##         output.write(`preferences['river color'].getRGB()`+'\n')
##         output.write(`preferences['background color'].getRGB()`+'\n')
##         output.write(preferences['GSTARS location']+'\n')
##         output.close()

        for f in self.frameList:
            if f.doc.canClose() == None: return

        java.lang.System.exit(0)

    def windowOrganize(self, event):
        """Window organize menu item callback.  Vertically tiles any views
        and helper windows.
        """
        height = float(self.getBounds().getHeight()) - 80
        width = float(self.getBounds().getWidth())

        cnt = len(self.frameList)

        for iframe in range(cnt):
            self.frameList[iframe].setBounds(
                0, int(height/cnt * iframe),
                int(width * .66), int(height/cnt))

        nframes = 0
        if self.geometryFrame: nframes = nframes + 1
        if self.sedimentFrame: nframes = nframes + 1
        if self.boundaryFrame: nframes = nframes + 1
        if self.outputFrame: nframes = nframes + 1

        # Add in info windows
        iframe = -1
        if self.geometryFrame and nframes > 0:
            if self.geometryFrame.isVisible():
                iframe = iframe + 1
                self.geometryFrame.setBounds(
                    int(width * .67), int(height/nframes * iframe),
                    int(width * .33), int(height/nframes))
        if self.sedimentFrame and nframes > 0:
            if self.sedimentFrame.isVisible():
                iframe = iframe + 1
                self.sedimentFrame.setBounds(
                    int(width * .67), int(height/nframes * iframe),
                    int(width * .33), int(height/nframes))
        if self.boundaryFrame and nframes > 0:
            if self.boundaryFrame.isVisible():
                iframe = iframe + 1
                self.boundaryFrame.setBounds(
                    int(width * .67), int(height/nframes * iframe),
                    int(width * .33), int(height/nframes))
        if self.outputFrame and nframes > 0:
            if self.outputFrame.isVisible():
                iframe = iframe + 1
                self.outputFrame.setBounds(
                    int(width * .67), int(height/nframes * iframe),
                    int(width * .33), int(height/nframes))

        return

    def helpContents(self, event):
        """About menu item callback.
        """
        #hsURL = HelpSet.findHelpSet(None, "..\\help\\gstars.hs")
        hsURL = HelpSet.findHelpSet(None, "help/gstars.hs")
        hs = HelpSet(None, hsURL)

        hb = hs.createHelpBroker()
        hb.setDisplayed(1)

        return

    def showHelp(self, event):
        """Help nmenu item callback
        """
        osName = java.lang.System.getProperty("os.name" );
        if osName == "Windows NT" or osName == "Windows 2000":
            exec_cmd = "cmd.exe /c start"
        else:
            exec_cmd = "start" ;

##         print exec_cmd + ' /c help\\Manual.pdf'
        self.p = java.lang.Runtime.getRuntime().exec(
            exec_cmd + " help\\Manual.pdf")
##      self.p = java.lang.Runtime.getRuntime().exec("start help\\Manual.pdf")
        return

    def helpAbout(self, event):
        """About menu item callback.
        """
        self.aboutdlg = swing.JDialog(self, "About GSTARS")
        self.aboutdlg.setSize(426, 600)
        self.aboutdlg.setContentPane(GSAboutBoxJPanel())
        self.aboutdlg.setLocationRelativeTo(self)
        self.aboutdlg.setVisible(1)

        return

    def hasOutput(self, doc, b):
        """Enable buttons and xsection dialog widgets dealing with output.
        boolean b
        """
        for frame in self.frameList:
            if isinstance(frame.doc, doc.__class__):
                frame.outputPaneButton.setEnabled(b)

        # Popdown the output dialogs if no output is available.
        if not b and self.outputFrame != None:
            self.outputFrame.setVisible(0)

        return

    def showGeometryWindow(self, doc):
        """Popup the geometry view.
        doc: GSTARSInputDoc
        side-effects: assigns to self.geometryFrame
        """
        if self.geometryFrame == None or self.geometryFrame.isClosed():
            height = float(self.getBounds().getHeight()) - 50
            width = float(self.getBounds().getWidth())

            self.geometryFrame = GSTARSGeometryView(doc)
            self.geometryFrame.setBounds(
                int(width * .67), 0,
                int(width * .33), int(height/4))
            self.desktop.add(
                self.geometryFrame, swing.JDesktopPane.PALETTE_LAYER)

        self.geometryFrame.setVisible(1)
        self.geometryFrame.moveToFront()
        return

    def showSedimentWindow(self, doc):
        """Popup the sediment view.
        doc: GSTARSInputDoc
        side-effects: assigns to self.sedimentFrame
        """
        if self.sedimentFrame == None or self.sedimentFrame.isClosed():
            height = float(self.getBounds().getHeight()) - 50
            width = float(self.getBounds().getWidth())

            self.sedimentFrame = GSTARSSedimentView(doc)
            self.sedimentFrame.setBounds(
                int(width * .67), int(height/4),
                int(width * .33), int(height/4))
            self.desktop.add(
                self.sedimentFrame, swing.JDesktopPane.PALETTE_LAYER)

        self.sedimentFrame.setVisible(1)
        self.sedimentFrame.moveToFront()
        return

    def showBoundaryWindow(self, doc):
        """Popup the boundary view.
        doc: GSTARSInputDoc
        side-effects: assigns to self.boundaryFrame
        """
        if self.boundaryFrame == None or self.boundaryFrame.isClosed():
            height = float(self.getBounds().getHeight()) - 50
            width = float(self.getBounds().getWidth())

            self.boundaryFrame = GSTARSBoundaryView(doc)
            self.boundaryFrame.setBounds(
                int(width * .67), int(height/4 * 2),
                int(width * .33), int(height/4))
            self.desktop.add(
                self.boundaryFrame, swing.JDesktopPane.PALETTE_LAYER)

        self.boundaryFrame.setVisible(1)
        self.boundaryFrame.moveToFront()
        return

    def showOutputWindow(self, doc):
        """Popup the output view.
        doc: GSTARSInputDoc
        side-effects: assigns to self.outputFrame
        """
        if self.outputFrame == None or self.outputFrame.isClosed():
            height = float(self.getBounds().getHeight()) - 50
            width = float(self.getBounds().getWidth())

            self.outputFrame = GSTARSOutputView(doc)
            self.outputFrame.setBounds(
                int(width * .67), int(height/4 * 3),
                int(width * .33), int(height/4))
            self.desktop.add(
                self.outputFrame, swing.JDesktopPane.PALETTE_LAYER)

        self.outputFrame.setVisible(1)
        self.outputFrame.moveToFront()
        return

    def showXSecControlDlg(self, doc):
        """Popup the cross-section controller dialog.
        doc: GSTARSInputDoc
        side-effects: assigns to self.outputFrame
        """
        if self.xsecControlDlg == None:
            self.xsecControlDlg = GSXSecControlDlg(self)

        nxsections = len(doc.xSectionData)
        self.xsecControlDlg.setNXSections(nxsections)

        if doc.xplData:
            ntimeperiods = len(doc.xplData.timeseriesInfo) / nxsections
            self.xsecControlDlg.setNTimePeriods(ntimeperiods-1)

        self.xsecControlDlg.newXSec = doc.newControllerXSec
        self.xsecControlDlg.newTime = doc.newControllerTime

        self.xsecControlDlg.setVisible(1)
        self.xsecControlDlg.setLocationRelativeTo(self)

    def updateAll(self, doc):
        """Update all the views of the doc.
        doc: the document type.
        returns: None
        side-effects: update is called on all views of the document.
        """
        for frame in self.frameList:
            if isinstance(frame.doc, doc.__class__):
                frame.updateView()


if __name__ == '__main__':
    gui = gstars()
    screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize()
    frameSize = gui.getSize()
    if frameSize.height > screenSize.height:
        frameSize.height = screenSize.height
    if frameSize.width > screenSize.width:
        frameSize.width = screenSize.width

    gui.setLocation(
        (screenSize.width - frameSize.width) / 2,
        (screenSize.height - frameSize.height) / 2)

    #gui.setLocation(100, 100)
    #gui.size = (500, 500)
    print 'setting visible'
    gui.visible=1
