package usbr.gstarsgui;

import java.util.Vector;
import usbr.gstarsgui.Misc;
import javax.swing.*;

/**
 * This type was created in VisualAge.
 */
public class GenericTableModel extends javax.swing.table.AbstractTableModel {
	// This pair of vectors will store the table information.
	public Vector m_tableDataArray[] = null;

	// This will be set by the calling procedure.  This data will be copied to the tableDataArray.
	public Vector m_resultDataArray[] = null;

	public java.lang.String[] m_columnNames = null;
	public boolean[] m_isColumnEditable = null;

	
	public int maxRowCount = Integer.MAX_VALUE;
	public Object newTableValue = new String();
	public Object newTableValueArray[] = null;
	public boolean isNumbered = false;
	protected int colOffset = 0;
	public Object defaultValue = null;
/**
 * GenericTableModel constructor comment.
 */
public GenericTableModel() {
	super();
}
/**
 * This method was created in VisualAge.
 * @param tableData java.util.Vector
 * @param colNames java.lang.String[]
 * @param isNumbered boolean
 * @param maxRows int
 */
public GenericTableModel(Vector[] tableData, Object zeroDataVal[], String[] colNames, boolean isNumbered, int maxRows) {
	setData(tableData);
	initialize(zeroDataVal, colNames);
	setMaxRowCount(maxRows);
	this.isNumbered = isNumbered;
}
/**
 * This method was created in VisualAge.
 * @param tableData java.util.Vector
 * @param colNames java.lang.String[]
 * @param isNumbered boolean
 * @param maxRows int
 */
public GenericTableModel(Vector[] tableData, Object zeroDataVal, String[] colNames, boolean isNumbered, int maxRows) {
	setData(tableData);
	initialize(zeroDataVal, colNames);
	setMaxRowCount(maxRows);
	this.isNumbered = isNumbered;
}
/**
 * This method was created in VisualAge.
 */
public void commitTableData() {
	if (m_tableDataArray != null)  {
		m_resultDataArray = new Vector [m_tableDataArray.length];
		for (int ilength=0; ilength<m_tableDataArray.length; ilength++)  {
			m_resultDataArray[ilength] = new Vector();
			for (int idata=0; idata<m_tableDataArray[ilength].size(); idata++)  {
				if (m_tableDataArray[ilength].elementAt(idata).toString() == "") break;	
				m_resultDataArray[ilength].addElement(m_tableDataArray[ilength].elementAt(idata));
			}
		}
	}
	else m_resultDataArray = null;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param whichRow int
 */
public boolean deleteRow(int whichRow) {
	try {
		for (int ilength=0; ilength<m_tableDataArray.length; ilength++)  {
			m_tableDataArray[ilength].removeElementAt(whichRow);
		}
	} catch (ArrayIndexOutOfBoundsException e) {
		//e.printStackTrace();
		return false;
	}
	
	if (m_tableDataArray.length > 0) {
		fireTableRowsDeleted(whichRow-1, m_tableDataArray[0].size());
	}

	return true;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param whichRows int[]
 */
public boolean deleteRows(int whichRows[]) {
	for (int i=whichRows.length-1; i>=0; i--)  {
		if (!deleteRow(whichRows[i])) continue;
	}
	fireTableStructureChanged();
	return true;
}
/**
 * This method was created in VisualAge.
 * @return int
 */
public int getActualRowCount() {
	if (m_tableDataArray != null && m_tableDataArray.length > 0)
		return m_tableDataArray[0].size();
	else
		return 0;
}
/**
 * getColumnCount method comment.
 */
public int getColumnCount() {
	if (m_tableDataArray == null) return colOffset;
	else return m_tableDataArray.length + colOffset;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param column int
 */
public String getColumnName(int column) {
	return m_columnNames[column];
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object getDefaultValue() {
	return defaultValue;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getIsNumbered() {
	return isNumbered;
}
/**
 * This method was created in VisualAge.
 * @return int
 */
public int getMaxRowCount() {
	return maxRowCount;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object getNewTableValue() {
	return newTableValue;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object getNewTableValue(int idx) {
	if (newTableValueArray != null)  {
		return newTableValueArray[idx];
	}
	else {
		return newTableValue;
	}
}
/**
 * getRowCount method comment.
 */
public int getRowCount() {
	if (m_tableDataArray != null && m_tableDataArray.length > 0)
		return Math.min(m_tableDataArray[0].size()+1, getMaxRowCount());
	else
		return 1;
}
/**
 * getValueAt method comment.
 */
public Object getValueAt(int arg1, int arg2) {
	if (getIsNumbered() && arg2 == 0) return new Integer(arg1+1);
	else if (arg1 == m_tableDataArray[arg2-colOffset].size()) {
		return instantiateNewValue(arg2-colOffset);
	}
	else return m_tableDataArray[arg2-colOffset].elementAt(arg1);
}
/**
 * This method was created in VisualAge.
 * @param zeroDataInstance java.lang.Object
 * @param colNames String[]
 */
public void initialize(Object zeroDataInstance[], String[] colNames) {
	setNewTableValue(zeroDataInstance);
	m_columnNames = colNames;
}
/**
 * This method was created in VisualAge.
 * @param zeroDataInstance java.lang.Object
 * @param colNames String[]
 */
public void initialize(Object zeroDataInstance, String[] colNames) {
	setNewTableValue(zeroDataInstance);
	m_columnNames = colNames;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param whichRow int
 */
public boolean insertRow(int whichRow) {
	try {
		for (int ilength=0; ilength<m_tableDataArray.length; ilength++)  {
			m_tableDataArray[ilength].insertElementAt(instantiateNewValue(ilength), whichRow);
		}
	} catch (ArrayIndexOutOfBoundsException e) {
		return false;
	}
	
	if (m_tableDataArray.length > 0) fireTableRowsInserted(whichRow, m_tableDataArray[0].size());
	return true;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object instantiateDefaultValue() {
	Object retval = null;
	try {
		retval = Misc.cloneObject(getDefaultValue());
	} catch (Exception e) {
		e.printStackTrace();
	}
	return retval;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object instantiateNewValue(int col) {
	//return (getNewTableValue().getClass()) (new Object());
	//return (Integer) (new Object());
	Object retval = null;
	try {
		retval = Misc.cloneObject(getNewTableValue(col));
	} catch (Exception e) {
		e.printStackTrace();
	}
	return retval;
	
	/*	
	try {
		//Object newVal = getNewTableValue().getClass().getConstructor(null).newInstance(null);
		
		Class objClass = getNewTableValue().getClass();
		//Object newVal = getNewTableValue().getClass().newInstance();
		Object newVal = objClass.getConstructor(null).newInstance(null);
		return newVal;
	} catch (NoSuchMethodException e) {
		e.printStackTrace();
	} catch (SecurityException e) {
		e.printStackTrace();
	} catch (InstantiationException e) {
		e.printStackTrace();
	} catch (IllegalAccessException e) {
		e.printStackTrace();
	} catch (java.lang.reflect.InvocationTargetException e) {
		e.printStackTrace();
	}
	return new String();
	*/
}
/**
 * This method was created in VisualAge.
 * @return java.lang.Object
 */
public Object instantiateNewValue(Object copyVal, int col) {
	//return (getNewTableValue().getClass()) (new Object());
	//return (Integer) (new Object());
	/*
	Object retval = null;
	try {
		retval = Misc.cloneObject(getNewTableValue());
	} catch (Exception e) {
		e.printStackTrace();
	}
	return retval;
	
	*/	
	try {
		//Object newVal = getNewTableValue().getClass().getConstructor(null).newInstance(null);
		
		Class objClass = getNewTableValue(col).getClass();
		Class argList[] = new Class [1];
		argList[0] = copyVal.getClass();
		java.lang.reflect.Constructor objConstructor = objClass.getConstructor(argList);
		Object objList[] = new Object [1];
		objList[0] = copyVal;
		return objConstructor.newInstance(objList);
		
		//Object newVal = getNewTableValue().getClass().newInstance();
		//Object newVal = objClass.getConstructor(null).newInstance();
		//return newVal;
	} catch (NoSuchMethodException e) {
		e.printStackTrace();
	} catch (SecurityException e) {
		e.printStackTrace();
	} catch (InstantiationException e) {
		e.printStackTrace();
	} catch (IllegalAccessException e) {
		e.printStackTrace();
	} catch (java.lang.reflect.InvocationTargetException e) {
		e.printStackTrace();
	}

	JOptionPane.showMessageDialog(null, "Unable to convert " + copyVal + " to type " + getNewTableValue(col).getClass().getName(), "Table New Value", JOptionPane.ERROR_MESSAGE);
	return null;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param rowIndex int
 * @param columnIndex int
 */
public boolean isCellEditable(int rowIndex, int columnIndex) {
	if (getIsNumbered() && columnIndex == 0) return false;
	else return m_isColumnEditable[columnIndex-colOffset];
}
/**
 * This method was created in VisualAge.
 * @param ncols int
 */
public void resizeColumns(int ncols, java.lang.String newColNames[]) {
	if (ncols <= 0) {
		System.out.println("Invalid request to resizeColumns::GenericTableModel: ncols  == " + ncols);
		return;
	}

	m_columnNames = newColNames;
	
	int oldLength = 0;
	if (m_tableDataArray != null) oldLength = m_tableDataArray.length;

	if (ncols == oldLength) return;  // Nothing to do.

	System.out.println("Starting resize.  Ncols is " + ncols + ". Old ncols is " + oldLength);
	
	// Shrink/enlarge the table to display 'ncols' columns.
	Vector newTableDataArray[] = new Vector [ncols];

	if (ncols < oldLength)  {
		// Remove columns
		for (int icol=0; icol<ncols; icol++)  {
			newTableDataArray[icol] = m_tableDataArray[icol];
		}
	}
	else if (ncols > oldLength)  {
		for (int icol=0; icol<oldLength; icol++)  {
			newTableDataArray[icol] = m_tableDataArray[icol];
		}
		
		// Create new columns.
		int nrows = 0;
		if (m_tableDataArray != null && m_tableDataArray.length > 0)  {
			nrows = m_tableDataArray[0].size();
		}
		for (int icol=oldLength; icol<ncols; icol++)  {
			System.out.println("Adding column");
			Vector newV = new Vector();
			for (int r=0; r<nrows; r++)  {
				newV.addElement(getDefaultValue());
			}
			System.out.println("Success instatiating default");
			newTableDataArray[icol] = newV;
		}
	}
		
	m_tableDataArray = newTableDataArray;

	// Assume that all columns are editable for now.
	m_isColumnEditable = new boolean [m_tableDataArray.length];
	for (int iedit=0; iedit<m_tableDataArray.length; m_isColumnEditable[iedit++] = true);

	fireTableStructureChanged();
}
/**
 * This method was created in VisualAge.
 * @param x java.util.Vector
 * @param y java.util.Vector
 */
public void setData(Vector newData[]) {
	m_resultDataArray = newData;
	m_tableDataArray = new Vector [newData.length];

	for (int ilength=0; ilength<m_resultDataArray.length; ilength++)  {
		m_tableDataArray[ilength] = new Vector();
		for (int i=0; i<m_resultDataArray[ilength].size(); i++)  {
			m_tableDataArray[ilength].addElement(m_resultDataArray[ilength].elementAt(i));
		}
	}

	// Reset editable data if the number of rows has changed.
	if (m_isColumnEditable == null || m_isColumnEditable.length != m_tableDataArray.length)  {
		m_isColumnEditable = new boolean [m_tableDataArray.length];
		for (int iedit=0; iedit<m_tableDataArray.length; m_isColumnEditable[iedit++] = true);
	}
	
	fireTableStructureChanged();
	//fireTableChanged();
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.Object
 */
public void setDefaultValue(Object newValue) {
	this.defaultValue = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue boolean
 */
public void setIsNumbered(boolean newValue) {
	this.isNumbered = newValue;
	this.colOffset = (newValue ? 1 : 0);

	fireTableStructureChanged();
}
/**
 * This method was created in VisualAge.
 * @param newValue int
 */
public void setMaxRowCount(int newValue) {
	this.maxRowCount = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.Object
 */
public void setNewTableValue(Object newValue[]) {
	this.newTableValueArray = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.Object
 */
public void setNewTableValue(Object newValue) {
	this.newTableValue = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newRowCount int
 */
public void setRows(int newRowCount) {
	for (int i=0; i<m_tableDataArray.length; m_tableDataArray[i++].setSize(newRowCount));

	fireTableDataChanged();
	return;
}
/**
 * This method was created in VisualAge.
 * @param aValue java.lang.Object
 * @param rowIndex int
 * @param columnIndex int
 */
public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
	int cidx = columnIndex - colOffset;
	if (cidx >= 0 && cidx < m_tableDataArray.length)  {
		if (rowIndex == m_tableDataArray[cidx].size() && rowIndex < getMaxRowCount()) {
			// Create space for new row.
			for (int ilength=0; ilength<m_tableDataArray.length; ilength++)  {
				m_tableDataArray[ilength].addElement(instantiateNewValue(ilength));
			}
			fireTableRowsInserted(rowIndex, rowIndex+1);
		}
		if (rowIndex < getRowCount())
			m_tableDataArray[cidx].setElementAt(instantiateNewValue(aValue, cidx), rowIndex);
	}
}
}