package usbr.gstarsgui;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.datatransfer.*;
import java.util.StringTokenizer;

import java.awt.*;

/**
 * This type was created in VisualAge.
 */
public class JExTable extends JTable implements ClipboardOwner, java.awt.event.ActionListener, java.awt.event.KeyListener, java.awt.event.MouseListener {
	public JMenuItem jCopyMenuitem = null;
	public JMenuItem jPasteMenuitem = null;
	public JMenuItem jInsertMenuitem = null;
	public JMenuItem jDeleteMenuitem = null;
	public JPopupMenu jPopupMenu = null;
/**
 * JExTable constructor comment.
 */
public JExTable() {
	super(new GenericTableModel());
	initialize();
}
/**
 * JExTable constructor comment.
 * @param rowData java.lang.Object[][]
 * @param columnNames java.lang.Object[]
 */
public JExTable(java.lang.Object[][] rowData, java.lang.Object[] columnNames) {
	super(rowData, columnNames);
	initialize();
}
/**
 * JExTable constructor comment.
 * @param numRows int
 * @param numColumns int
 */
public JExTable(int numRows, int numColumns) {
	super(numRows, numColumns);
	initialize();
}
/**
 * JExTable constructor comment.
 * @param dm javax.swing.table.TableModel
 */
public JExTable(javax.swing.table.TableModel dm) {
	super(dm);
	initialize();
}
/**
 * JExTable constructor comment.
 * @param dm javax.swing.table.TableModel
 * @param cm javax.swing.table.TableColumnModel
 */
public JExTable(javax.swing.table.TableModel dm, javax.swing.table.TableColumnModel cm) {
	super(dm, cm);
	initialize();
}
/**
 * JExTable constructor comment.
 * @param dm javax.swing.table.TableModel
 * @param cm javax.swing.table.TableColumnModel
 * @param sm javax.swing.ListSelectionModel
 */
public JExTable(javax.swing.table.TableModel dm, javax.swing.table.TableColumnModel cm, ListSelectionModel sm) {
	super(dm, cm, sm);
	initialize();
}
/**
 * JExTable constructor comment.
 * @param rowData java.util.Vector
 * @param columnNames java.util.Vector
 */
public JExTable(java.util.Vector rowData, java.util.Vector columnNames) {
	super(rowData, columnNames);
	initialize();
}
/**
 * This method was created in VisualAge.
 */
public void actionPerformed(java.awt.event.ActionEvent e) {
	if ((e.getSource() == getJCopyMenuitem()) ) {
		doCopy();
	}	
	else if ((e.getSource() == getJPasteMenuitem()) ) {
		doPaste();
	}
	else if ((e.getSource() == getJInsertMenuitem()) ) {
		doInsert();
	}
	else if ((e.getSource() == getJDeleteMenuitem()) ) {
		doDelete();
	}
	else if (e.getActionCommand() == "keyPaste")  {
		System.out.println("keypaste!");
		doPaste();
	}
	else if (e.getActionCommand() == "keyCopy")  {
		System.out.println("keycopy!");
		doCopy();
	}
	else if (e.getActionCommand() == "keyInsert")  {
		System.out.println("keyinsert!");
		doInsert();
	}
	else if (e.getActionCommand() == "keyDelete")  {
		System.out.println("keydelete!");
		doDelete();
	}
}
/**
 * This method was created in VisualAge.
 */
public void doCopy() {
	//GenericTableModel gtm = (GenericTableModel)getModel();
	TableModel gtm = getModel();
	//java.util.Vector[] td = gtm.m_tableDataArray;

	String retStr = "";

	int rowSel[] = getSelectedRows();
	int colSel[] = getSelectedColumns();

	int rowmin = rowSel[0];
	int rowmax = rowSel[rowSel.length-1];

	int colmin = colSel[0];
	int colmax = colSel[colSel.length-1];

	for (int r=rowmin; r<=rowmax; r++)  {
		for (int c=colmin; c<=colmax; c++)  {
			if (c > colmin) retStr += "\t";
			retStr += gtm.getValueAt(r, c);
		}
		retStr += "\n";
	}

	// Assume contiguous selection.  Note that if the table is numbered, then add in a bogus first column.
//	if (rowSel.length > 0 && colSel.length > 0)  {
//		int rowmin = rowSel[0];
//		int rowmax = rowSel[rowSel.length-1];
//		if (rowmax > td[0].size()-1) rowmax = td[0].size()-1;

//		int colmin = colSel[0];
//		int colmax = colSel[colSel.length-1];

//		int colOffset = gtm.getIsNumbered() ? 1 : 0;
		
//		for (int r=rowmin; r<=rowmax; r++)  {
//			for (int c=colmin; c<=colmax; c++)  {
//				if (c > colmin) retStr += "\t";
//				if (c == 0 && gtm.getIsNumbered()) {
//					retStr += String.valueOf(r+1);
//				}
//				else retStr += td[c-colOffset].elementAt(r);
//			}
//			retStr += "\r\n";
//		}
//	}
		
	StringSelection contents = new StringSelection(retStr);
	getToolkit().getSystemClipboard().setContents(contents, this);
}
/**
 * This method was created in VisualAge.
 */
public void doDelete() {
	// Delete all selected rows.
	int rows[] = getSelectedRows();
	for (int irow=0; irow<rows.length; irow++)  {
		((DefaultTableModel)getModel()).removeRow(rows[0]);
	}
}
/**
 * This method was created in VisualAge.
 */
public void doInsert() {
	((DefaultTableModel)getModel()).insertRow(getSelectedRow(), (Object[])null);
}
/**
 * This method was created in VisualAge.
 */
public void doPaste() {
	java.awt.datatransfer.Transferable content = getToolkit().getSystemClipboard().getContents(this);
	if (content != null) {
		String dstData = "";
		try {
			dstData = (String) content.getTransferData(DataFlavor.stringFlavor);
			System.out.println(dstData);
		}
		catch (Exception e) {
			System.out.println("Couldn't get contents in format: " + DataFlavor.stringFlavor.getHumanPresentableName() + ": " + e);
		}

		// Count the number of elements.  Make sure that there is a terminating newline.
		dstData += "\r\n";

		// Check that there are the span of clipboard data will fit.
		StringTokenizer st = new StringTokenizer(dstData, "\r\n");
		int nRows = st.countTokens();
		System.out.println("There are " + nRows + " lines.");

		// Count columns
		st = new StringTokenizer(dstData, "\t\r\n");
		int nTokens = st.countTokens();
		System.out.println("There are " + nTokens + " tokens.");
		
		int nCols = nTokens / nRows;

		// See if the clipboard data will fit.
		int startRow = getSelectedRow();
		int startCol = getSelectedColumn();
		//GenericTableModel gtm = (GenericTableModel)getModel();
		TableModel gtm = getModel();
		
		int r=startRow;
		int c=startCol;
		
		while (st.hasMoreTokens())  {
			gtm.setValueAt(st.nextToken(), r, c);

			c++;
			if (c == startCol + nCols) {
				c = startCol;
				r++;
			}
		}
		tableChanged(new javax.swing.event.TableModelEvent(getModel()));
	}
	return;
}
/**
 * This method was created in VisualAge.
 * @return TableCellEditor
 * @param columnClass java.lang.Class
 */
public TableCellEditor getDefaultEditor(Class columnClass) {
	TableCellEditor cellEditor = super.getDefaultEditor(columnClass);
	//if (isCellEditable(getEditingRow(), getEditingColumn())) {
	//	((DefaultCellEditor)cellEditor).getComponent().setBackground(Color.cyan);
	//}
	return cellEditor;
}
/**
 * This method was created in VisualAge.
 * @return javax.swing.JMenuItem
 */
public JMenuItem getJCopyMenuitem() {
	if (jCopyMenuitem == null) {
		jCopyMenuitem = new javax.swing.JMenuItem();
		jCopyMenuitem.setName("JCopyMenuitem");
		jCopyMenuitem.setText("Copy");
	};
	return jCopyMenuitem;
}
/**
 * This method was created in VisualAge.
 * @return javax.swing.JMenuItem
 */
public JMenuItem getJDeleteMenuitem() {
	if (jDeleteMenuitem == null) {
		jDeleteMenuitem = new javax.swing.JMenuItem();
		jDeleteMenuitem.setName("JDeleteMenuitem");
		jDeleteMenuitem.setText("Delete");
	};
	return jDeleteMenuitem;
}
/**
 * This method was created in VisualAge.
 * @return javax.swing.JMenuItem
 */
public JMenuItem getJInsertMenuitem() {
	if (jInsertMenuitem == null) {
		jInsertMenuitem = new javax.swing.JMenuItem();
		jInsertMenuitem.setName("JInsertMenuitem");
		jInsertMenuitem.setText("Insert");
	};
	return jInsertMenuitem;
}
/**
 * This method was created in VisualAge.
 * @return javax.swing.JMenuItem
 */
public JMenuItem getJPasteMenuitem() {
	if (jPasteMenuitem == null) {
		jPasteMenuitem = new javax.swing.JMenuItem();
		jPasteMenuitem.setName("JPasteMenuitem");
		jPasteMenuitem.setText("Paste");
	};
	return jPasteMenuitem;
}
/**
 * This method was created in VisualAge.
 * @return javax.swing.JMenu
 */
public JPopupMenu getJPopupMenu() {
	if (jPopupMenu == null) {
		jPopupMenu = new javax.swing.JPopupMenu("Operations");
		jPopupMenu.setName("JPopupMenu1");
		jPopupMenu.setLabel("Foo!");
		jPopupMenu.setBorderPainted(true);
		jPopupMenu.add(getJCopyMenuitem());
		jPopupMenu.add(getJPasteMenuitem());
		jPopupMenu.add(getJInsertMenuitem());
		jPopupMenu.add(getJDeleteMenuitem());
	};
	return jPopupMenu;
}
/**
 * This method was created in VisualAge.
 */
public void initialize() {
	//this.addActionListener(this);
	this.addMouseListener(this);
	this.addKeyListener(this);
	getJCopyMenuitem().addActionListener(this);
	getJPasteMenuitem().addActionListener(this);
	getJDeleteMenuitem().addActionListener(this);
	getJInsertMenuitem().addActionListener(this);
 
	setCellSelectionEnabled(true);
	setSelectionMode(1);
	setAutoResizeMode(AUTO_RESIZE_ALL_COLUMNS);

	try {
		setDefaultEditor(java.lang.Class.forName("java.lang.Object"), new JExTableEditor(new JTextField()));
	} catch (java.lang.ClassNotFoundException e) {
	}
	
	this.registerKeyboardAction(this, "keyPaste",    
			   KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.Event.CTRL_MASK),
			   JComponent.WHEN_FOCUSED);
	this.registerKeyboardAction(this, "keyCopy",    
			   KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.Event.CTRL_MASK),
			   JComponent.WHEN_FOCUSED);
	this.registerKeyboardAction(this, "keyInsert",    
			   KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_INSERT, 0),
			   JComponent.WHEN_FOCUSED);
	this.registerKeyboardAction(this, "keyDelete",    
			   KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DELETE, 0),
			   JComponent.WHEN_FOCUSED);

}
/**
 * keyPressed method comment.
 */
public void keyPressed(java.awt.event.KeyEvent e) {
}
/**
 * keyReleased method comment.
 */
public void keyReleased(java.awt.event.KeyEvent e) {
}
/**
 * keyTyped method comment.
 */
public void keyTyped(java.awt.event.KeyEvent e) {
	//System.out.println("Keyevent: " + e);
	if (e.getKeyCode() == java.awt.event.KeyEvent.VK_V && e.isControlDown())  {
		//System.out.println("Pasting");
		editingCanceled(null);
		// If we don't cancel the edit, then the edited cell won't get pasted properly.
		doPaste();
	}
	else if (e.getKeyChar() == java.awt.event.KeyEvent.VK_C && e.isControlDown())  {
		//System.out.println("Copying");
		doCopy();
	}		
	else if (e.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE)  {		
		//int whichRows[] = getND_Table().getSelectedRows();
		//getND_Table().editingCanceled(null);
		//getRoughnessTableModel().deleteRows(whichRows);
		//if (whichRows.length > 0) getND_Table().setEditingRow(whichRows[0]);
	}
	else if (e.getKeyCode() == java.awt.event.KeyEvent.VK_INSERT)  {		
		//int whichRow = getND_Table().getSelectedRow();
		//getND_Table().editingCanceled(null);
		//getRoughnessTableModel().insertRow(whichRow);
		//getND_Table().setEditingRow(whichRow);
		//getND_Table().editCellAt(whichRow, 0, new java.util.EventObject(new String()));
	}
}
/**
 * This method was created in VisualAge.
 */
public void lostOwnership(Clipboard clipboard, Transferable contents) {
}
/**
 * mouseClicked method comment.
 */
public void mouseClicked(java.awt.event.MouseEvent e) {
}
/**
 * mouseEntered method comment.
 */
public void mouseEntered(java.awt.event.MouseEvent e) {
}
/**
 * mouseExited method comment.
 */
public void mouseExited(java.awt.event.MouseEvent e) {
}
/**
 * mousePressed method comment.
 */
public void mousePressed(java.awt.event.MouseEvent e) {
}
/**
 * mouseReleased method comment.
 */
public void mouseReleased(java.awt.event.MouseEvent e) {
	if (e.isPopupTrigger())  {
		getJPopupMenu().setLabel("Foo");
		getJPopupMenu().show(e.getComponent(), e.getX(), e.getY());
	}
}
/**
 * This method was created in VisualAge.
 * @param newModel javax.swing.table.TableModel
 */
public void setModel(TableModel newModel) {
	super.setModel(newModel);

	//sizeColumnsToFit(AUTO_RESIZE_ALL_COLUMNS);
}
}